module kp4_top(clk, pb, led);
	input clk;
	input [3:0] pb;
	output [3:0] led;
	wire [7:0] pc;
	wire [15:0] inst;
	wire [3:0] data_in, data_out;
	wire we;
	kp4_core kp4_core(.clk(clk), .reset(1'b0), .we(we),
		.pc(pc), .inst(inst), .data_in(data_in), .data_out(data_out));
	RAMB16_S18 rom(.CLK(clk), .WE(1'b0), .EN(1'b1), .SSR(1'b0),
		.ADDR({ 2'b0, pc }), .DI(16'b0), .DIP(2'b0), .DO(inst));
	reg [3:0] m[0:15];
	reg [3:0] led;
	always @(posedge clk) 
		if (we) 
			if (inst[4]) led <= data_out;
			else m[inst[3:0]] <= data_out;
	assign data_in = inst[4] ? pb : m[inst[3:0]];
endmodule

module kp4_core(clk, reset, pc, inst, we, data_in, data_out);
	input clk, reset;
	input [15:0] inst;
	input [3:0] data_in;
	output [7:0] pc;
	output [3:0] data_out;
	output we;
endmodule
